"activeSetLogCon" <-
function (x, w = NA, print = FALSE) 
{
    prec <- 10^(-10)
    n <- length(x)
    if (sum(x[2:n] <= x[1:n - 1]) > 0) {
        cat("We need strictly increasing numbers x(i)!\n")
    }
    if (max(is.na(w)) == 1) {
        w <- rep(1/n, n)
    }
    if (sum(w <= 0) > 0) {
        cat("We need strictly positive weights w(i)!\n")
    }
    w <- w/sum(w)
    phi <- LocalNormalize(x, 1:n * 0)
    IsKnot <- 1:n * 0
    IsKnot[c(1, n)] <- 1
    res1 <- LocalMLE(x, w, IsKnot, phi, prec)
    phi <- res1$phi
    L <- res1$L
    conv <- res1$conv
    H <- res1$H
    iter1 <- 1
    while ((iter1 < 500) & (max(H) > prec * mean(abs(H)))) {
        IsKnot_old <- IsKnot
        iter1 <- iter1 + 1
        tmp <- max(H)
        k <- (1:n) * (H == tmp)
        k <- min(k[k > 0])
        IsKnot[k] <- 1
        res2 <- LocalMLE(x, w, IsKnot, phi, prec)
        phi_new <- res2$phi
        L <- res2$L
        conv_new <- res2$conv
        H <- res2$H
        while ((max(conv_new) > prec * max(abs(conv_new)))) {
            JJ <- (1:n) * (conv_new > 0)
            JJ <- JJ[JJ > 0]
            tmp <- conv[JJ]/(conv[JJ] - conv_new[JJ])
            lambda <- min(tmp)
            KK <- (1:length(JJ)) * (tmp == lambda)
            KK <- KK[KK > 0]
            IsKnot[JJ[KK]] <- 0
            phi <- (1 - lambda) * phi + lambda * phi_new
            conv <- pmin(c(LocalConvexity(x, phi), 0))
            res3 <- LocalMLE(x, w, IsKnot, phi, prec)
            phi_new <- res3$phi
            L <- res3$L
            conv_new <- res3$conv
            H <- res3$H
            if (print == 1) {
                print(paste("iter1=", iter1, " / L=", round(L, 
                  4), " / max(H)=", round(max(H), 4), sep = ""))
            }
        }
        phi <- phi_new
        conv <- conv_new
        if (sum(IsKnot != IsKnot_old) == 0) {
            break
        }
        if (print == TRUE) {
            print(paste("iter1=", iter1, " / L=", round(L, 4), 
                " / max(H)=", round(max(H), 4), sep = ""))
        }
    }
    F <- LocalF(x, phi)
    return(list(x = x, phi = phi, IsKnot = IsKnot, L = L, F = F, 
        H = H))
}
